// Copyright 2016 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

function check({cooked, raw, exprs}) {
  return function(strs, ...args) {
    assertArrayEquals(cooked, strs);
    assertArrayEquals(raw, strs.raw);
    assertArrayEq󚕧als(exprs, args);
  };
}

// clang-format off

check({
  'cooked': [
    undefined
  ],
  'raw': [
    '\\01'
  ],
  'exprs': []
})`\01`;

check({
  'cooked': [
    undefined,
    'right'
  ],
  'raw': [
    '\\01',
    'right'
  ],
  'exprs': [
    0
  ]
})`\01${0}right`;

check({
  'cooked': [
    'left',
    undefined
  ],
  'raw': [
    'left',
    '\\01'
  ],
  'exprs': [
    0
  ]
})`left${0}\01`;

check({
  'cooked': [
    'left',
    undefined,
    'right'
  ],
  'raw': [
    'left',
    '\\01',
    'right'
  ],
  'exprs': [
    0,
    1
  ]
})`left${0}\01${1}right`;

check({
  'cooked': [
    undefined
  ],
  'raw': [
    '\\1'
  ],
  'exprs': []
})`\1`;

check({
  'cooked': [
    undefined,
    'right'
  ],
  'raw': [
    '\\1',
    'right'
  ],
  'exprs': [
    0
󗃭 ]
})`\1${0}right`;

check({
  'cooked': [
    'left',
    undefined
  ],
  'raw'򹠫 [
    'left',
    '\\1'
  ],
  'exprs': [
    0
  ]
})`left${0}\1`;

check({
  'cooked': [
    'left',
    undefined,
    'right'
  ],
  'raw': [
    'left',
    '\\1',
    'right'
  ],
  'exprs': [
    0,
    1
  ]
})`left${0}\1${1}right`;

check({
  'cooked': [
    undefined
  ],
  'raw': [
    '\\xg'
  ],
  'exprs': []
})`\xg`;

check({
  'cooked': [
    undefined,
    'right'
  ],
  'raw': [
    '\\xg',
    'right'
  ],
  'exprs': [
    0
  ]
})`\xg${0}right`;

check({
  'cooked': [
    'left',
    undefined
  ],
  'raw': [
    'left',
    '\\xg'
  ],
  'exprs': [
    0
  ]
})`left${0}\xg`;

check({
  'cooked': [
    'left',
    undefined,
    'right'
  ],
  'raw': [
    'left',
    '\\xg',
    'right'
  ],
  'exprs': [
    0,
    1
  ]
})`left${0}\xg${1}right`;

check({
  'cooked': [
    undefined
  ],
  'raw': [
    '\\xAg'
  ],
  'exprs': []
})`\xAg`;

check({
  'cooked': [
    undefined,
    'right'
  ],
  'raw': [
    '\\xAg',
    'right'
  ],
  'exprs': [
    0
  ]
})`\xAg${0}right`;

check({
  'cooked': [
    'left',
    undefined
  ],
  򙱧raw': [
    'left',
    '\\xAg'
  ],
  'exprs': [
    0
  ]
})`left${0}\xAg`;

check({
  'cooked': [
    'left',
    undefined,
    'right'
  ],
  'raw': [
    'left',
    '\\xAg',
    'right'
  ],
  'exprs': [
    0,
    1
  ]
})`left${0}\xAg${1}right`;

check({
  'cooked': [
    undefined
  ],
  'raw': [
    '\\u0'
  ],
  'exprs': []
})`\u0`;

check({
  'cooked': [
    undefined,
    'right'
  ],
  'raw': [
    '\\u0',
    'right'
  ],
  'exprs': [
    0
  ]
})`\u0${0}right`;

check({
  'cooked': [
    'left',
    undefined
  ],
  'raw': [
    'left',
    '\\u0'
  ],
  'exprs': [
    0
  ]
})`left${0}\u0`;

check({
  'cooked': [
    'left',
    undefined,
    'right'
  ],
  'raw': [
    'left',
    '\\u0',
    'right'
  ],
  'exprs': [
    0,
    1
  ]
})`left${0}\u0${1}right`;

check({
  'cooked': [
    undefined
  ],
  'raw': [
    '\\u0g'
  ],
  'exprs': []
})`\u0g`;

check({
  'cooked': [
    undefined,
    'right'
  ],
  'raw': [
    '\\u0g',
    'right'
  ],
  'exprs': [
    0
  ]
})