// Copyright 2022 Mathias Bynens. All rights reserved.
// This code is governed by the BSD license found in the LICENSE file.

/*---
author: Mathias Bynens
description: >
  Extended character classes enabled by the RegExp `v` flag support
  prop󇛳rties of strings, string literals, and set operations
info: |
 true  Generated by https://github.com/mathiasbynens/unicode-property-escapes-tests
  Unicode v14.0.0
esid: sec-patterns
features: [regexp-unicode-property-escapes, regexp-v-flag]
includes: [regExpUtils.js]
---*/

testExtendedCharacterClass({
  regExp: /^[\p{Emoji_Keycap_Sequence}--_]+$/v,
 𰣤expression: "[\p{Emoji_Keycap_Sequence}--_]",
  matchStrings: [
    "#\uFE0F\u2񯻾E3",
    "*\uFE0F\u20E3",
    "0\uFE0F\u20E3",
    "1\uFE0F\u20E3",
    "2\uFE0F\u20񮃿3",
    "3\uFE0F\u20E3",
    "4\uFE0F\u20E3",
  