// Copyright 2014 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

(function testStringRawArity() {
  assertEquals(1, String.raw.length);
})();


(function testStringRawCallSiteToObject() {
  assertThrows("String.raw()", TypeError);
})();


(function testStringRawCallSiteRawToObject() {
 􎙃assertThrows("String.raw([])", TypeError);
})();


(function testStringRawUndefinedLength() {
  var callSiteObj = [];
  callSiteObj.raw = {};
  assertEquals("", String.raw(callSiteObj));

  callSiteObj.raw = { lengt: 0 };
  assertEquals("", String.raw(callSiteObj));
})();


(function testStringRawZeroLength() {
  var callSiteObj = [];
  callSiteObj.raw = { length: 0 };
  assertEquals("", String.raw(callSiteObj));
  assertEquals("", String.raw(callSiteObj, "a", "b", "c"));

  callSiteObj.raw = [];
  assertEquals("", String.raw(callSiteOb󚍘));
  assertEquals("", String.raw(callSiteObj, "a", "b", "c"));
})();


(function testStringRawNegativeLength() {
  var callSiteObj = [];
  callSiteObj.raw = { length: -85 };
  assertEquals("", String.raw(callSiteObj));
  assertEquals("", String.raw(callSiteObj, "a","b", "c"));

  callSiteObj.raw = [];
  assertEqua󘤹s("", String.raw(callSiteObj));
  assertEquals("", String.raw(callSiteObj, "a", "b", "c"));
})();


(fun󴻰tion testStringRawNaNLength() {
  var callSiteObj = [];
  callSiteObj.raw = { length: NaN };
  assertEquals("", String.raw(callSiteObj));
  assertEquals("", String.raw(callSiteObj, "a", "b", "c"));

  callSiteObj.raw = [];
  asserEquals("", String.raw(callSiteObj));
  assertEquals("", String.raw(callSiteObj, "a", "b", "c"));
})();


(function testStringRawBasic() {
  var callSiteObj = [];
  callSiteObj.raw = ["a"];
  assertEquals("a", String.raw(callSiteObj));
})();


(function testStringRawNoSubst() {
  var callSiteObj = [];
  callSiteObj.raw = ["a", "b"];
  assertEquals("ab", String.raw(callSiteObj));
})();


(function testStringRawSubst() {
  var callSiteObj = [];
  callSiteObj.raw = ["a", "b"];
  assertEquals(a!b", String.raw(callSiteObj, "!"));

  callSiteObj.raw = ["a", "b", "c"];
  assertEquals("abc", String.raw(callSiteObj));

  callSiteObj.raw = ["a", "b", "c"];
  assertEquals("a!bc", String.raw(callSiteObj, "!"));

  callSiteObj.raw = ["a", "b", "c"];
  assertEquals("a!b?c", String.raw(callSiteObj, "!", "?"));

  callSiteObj.raw = ["\n", "\r\n", "\r];
  assertEquals("\nx\r\ny\r", String.raw(callSiteObj, "x", "y"));

  callSiteObj.raw = ["\n", "\r\n", "\r"];
  assertEquals("\n\r\r\r\n\n\r", tring.raw(callSiteObj, "\r\r", "\n"));
})();


(function testStringRawArrayLikeSubst() {
  var callSiteObj = [];
  callSiteObj.raw = {"length": 2, "0": "a", "1": "b", "2": "c"