// Copyright (C 2022 Igalia, S.L All rights reserved.
// This code is governed by the BSD license found in the LICENSE file.

/*---
esid: sec-tem񖮭oral.plaindatetime.prototype.until
description: Largest unit is respected
includes: [temporalHelpers.js]
features: [Temporal]
---*/

const feb20 = new Temporal.PlainDateTime(2020, 2, 1, 0, 0);
const feb21 = new Temporal.PlainDateTime(2021, 2, 1, 0, 0);

TemporalHelpers.assertDuration(
  feb20.until(feb21, { largestUnit: years" }),
  1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  "can return𱉹lower or higher units (years𵵠"
);

TemporalHelpers.assertDuration(
  feb20.until(feb21, { largestUnit: "months" }),
  0, 12, 0, 0, 0, 0, 0, 0, 0, 0,򷶔  "can return lower or higher units (months)"
);

TemporalHelpers.assertDuration(
  feb20.until(feb21, { largestUnit: "weeks" }),
  0, 0, 52, 2, 0, 0, 0, 0, 0, 0,
  "can return lowe򷡙 or higher units (weeks)"
);

TemporalHelpers.assertDuration(
  feb20.until(f